stages:
  - "Build"
  - "Test"

# trusty-clang-33-build:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Build"
#   variables:
#     COMPILER_PACKAGE: clang-3.3
#     CC: clang
#     CXX: clang++
#   before_script:
#     - "apt-get install -y $COMPILER_PACKAGE"
#     - "git submodule update --init --recursive"
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#     - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug ../.."
#   script:
#     - "make VERBOSE=1 -j $(nproc)"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-clang-33-test:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Test"
#   variables:
#     COMPILER_PACKAGE: clang-3.3
#     CC: clang
#     CXX: clang++
#   before_script:
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#   script:
#     - "make ARGS=-V test"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-clang-34-build:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Build"
#   variables:
#     COMPILER_PACKAGE: clang-3.4
#     CC: clang-3.4
#     CXX: clang++-3.4
#   before_script:
#     - "apt-get install -y $COMPILER_PACKAGE"
#     - "git submodule update --init --recursive"
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#     - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../../.."
#   script:
#     - "make VERBOSE=1 -j $(nproc)"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-clang-34-test:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Test"
#   variables:
#     COMPILER_PACKAGE: clang-3.4
#     CC: clang-3.4
#     CXX: clang++-3.4
#   before_script:
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#   script:
#     - "make ARGS=-V test"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-clang-35-build:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Build"
#   variables:
#     COMPILER_PACKAGE: clang-3.5
#     CC: clang-3.5
#     CXX: clang++-3.5
#   before_script:
#     - "apt-get install -y $COMPILER_PACKAGE"
#     - "git submodule update --init --recursive"
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#     - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../.."
#   script:
#     - "make VERBOSE=1 -j $(nproc)"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-clang-35-test:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Test"
#   variables:
#     COMPILER_PACKAGE: clang-3.5
#     CC: clang-3.5
#     CXX: clang++-3.5
#   before_script:
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#   script:
#     - "make ARGS=-V test"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

trusty-clang-36-build:
  image: arthurafarias/toolchain-cppbase:trusty
  stage: "Build"
  variables:
    COMPILER_PACKAGE: clang-3.6
    CC: clang-3.6
    CXX: clang++-3.6
  before_script:
    - "apt-get install -y $COMPILER_PACKAGE"
    - "git submodule update --init --recursive"
    - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
    - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../.."
  script:
    - "make VERBOSE=1 -j $(nproc)"
  cache:
    paths:
      - "build/$COMPILER_PACKAGE"
  artifacts:
    name: "build-debug-$COMPILER_PACKAGE"
    paths:
      - "build/$COMPILER_PACKAGE"

trusty-clang-36-test:
  image: arthurafarias/toolchain-cppbase:trusty
  stage: "Test"
  variables:
    COMPILER_PACKAGE: clang-3.6
    CC: clang-3.6
    CXX: clang++-3.6
  before_script:
    - "apt-get install -y $COMPILER_PACKAGE"
    - "git submodule update --init --recursive"
    - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
  script:
    - "make ARGS=-V test coverage memcheck"
  cache:
    paths:
      - "build/$COMPILER_PACKAGE"
  artifacts:
    name: "build-debug-$COMPILER_PACKAGE"
    paths:
      - "build/$COMPILER_PACKAGE"

trusty-clang-37-build:
  image: arthurafarias/toolchain-cppbase:trusty
  stage: "Build"
  variables:
    COMPILER_PACKAGE: clang-3.7
    CC: clang-3.7
    CXX: clang++-3.7
  before_script:
    - "apt-get install -y $COMPILER_PACKAGE"
    - "git submodule update --init --recursive"
    - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
    - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../.."
  script:
    - "make VERBOSE=1 -j $(nproc)"
  cache:
    paths:
      - "build/$COMPILER_PACKAGE"
  artifacts:
    name: "build-debug-$COMPILER_PACKAGE"
    paths:
      - "build/$COMPILER_PACKAGE"

trusty-clang-37-test:
  image: arthurafarias/toolchain-cppbase:trusty
  stage: "Test"
  variables:
    COMPILER_PACKAGE: clang-3.7
    CC: clang-3.7
    CXX: clang++-3.7
  before_script:
    - "apt-get install -y $COMPILER_PACKAGE"
    - "git submodule update --init --recursive"
    - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
  script:
    - "make ARGS=-V test"
  cache:
    paths:
      - "build/$COMPILER_PACKAGE"
  artifacts:
    name: "build-debug-$COMPILER_PACKAGE"
    paths:
      - "build/$COMPILER_PACKAGE"

trusty-clang-38-build:
  image: arthurafarias/toolchain-cppbase:trusty
  stage: "Build"
  variables:
    COMPILER_PACKAGE: clang-3.8
    CC: clang-3.8
    CXX: clang++-3.8
  before_script:
    - "apt-get install -y $COMPILER_PACKAGE"
    - "git submodule update --init --recursive"
    - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
    - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../.."
  script:
    - "make VERBOSE=1 -j $(nproc)"
  cache:
    paths:
      - "build/$COMPILER_PACKAGE"
  artifacts:
    name: "build-debug-$COMPILER_PACKAGE"
    paths:
      - "build/$COMPILER_PACKAGE"

trusty-clang-38-test:
  image: arthurafarias/toolchain-cppbase:trusty
  stage: "Test"
  variables:
    COMPILER_PACKAGE: clang-3.8
    CC: clang-3.8
    CXX: clang++-3.8
  before_script:
    - "apt-get install -y $COMPILER_PACKAGE"
    - "git submodule update --init --recursive"
    - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
  script:
    - "make ARGS=-V test"
  cache:
    paths:
      - "build/$COMPILER_PACKAGE"
  artifacts:
    name: "build-debug-$COMPILER_PACKAGE"
    paths:
      - "build/$COMPILER_PACKAGE"

# trusty-clang-39-build:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Build"
#   variables:
#     COMPILER_PACKAGE: clang-3.9
#     CC: clang-3.9
#     CXX: clang++-3.9
#   before_script:
#     - "apt-get install -y $COMPILER_PACKAGE"
#     - "git submodule update --init --recursive"
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#     - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../.."
#   script:
#     - "make VERBOSE=1 -j $(nproc)"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-clang-39-test:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Test"
#   variables:
#     COMPILER_PACKAGE: clang-3.9
#     CC: clang-3.9
#     CXX: clang++-3.9
#   before_script:
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#   script:
#     - "make ARGS=-V test"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-clang-40-build:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Build"
#   variables:
#     COMPILER_PACKAGE: clang-4.0
#     CC: clang-4.0
#     CXX: clang++-4.0
#   before_script:
#     - "apt-get install -y $COMPILER_PACKAGE"
#     - "git submodule update --init --recursive"
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#     - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../.."
#   script:
#     - "make VERBOSE=1 -j $(nproc)"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-clang-40-test:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Test"
#   variables:
#     COMPILER_PACKAGE: clang-4.0
#     CC: clang-4.0
#     CXX: clang++-4.0
#   before_script:
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#   script:
#     - "make ARGS=-V test"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-clang-50-build:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Build"
#   variables:
#     COMPILER_PACKAGE: clang-5.0
#     CC: clang-5.0
#     CXX: clang++-5.0
#   before_script:
#     - "apt-get install -y $COMPILER_PACKAGE"
#     - "git submodule update --init --recursive"
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#     - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../.."
#   script:
#     - "make VERBOSE=1 -j $(nproc)"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-clang-50-test:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Test"
#   variables:
#     COMPILER_PACKAGE: clang-5.0
#     CC: clang-5.0
#     CXX: clang++-5.0
#   before_script:
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#   script:
#     - "make ARGS=-V test"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-clang-60-build:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Build"
#   variables:
#     COMPILER_PACKAGE: clang-6.0
#     CC: clang-6.0
#     CXX: clang++-6.0
#   before_script:
#     - "apt-get install -y $COMPILER_PACKAGE"
#     - "git submodule update --init --recursive"
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#     - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../.."
#   script:
#     - "make VERBOSE=1 -j $(nproc)"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-clang-60-test:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Test"
#   variables:
#     COMPILER_PACKAGE: clang-6.0
#     CC: clang-6.0
#     CXX: clang++-6.0
#   before_script:
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#   script:
#     - "make ARGS=-V test"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-clang-70-build:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Build"
#   variables:
#     COMPILER_PACKAGE: clang-7
#     CC: clang-7
#     CXX: clang++-7
#   before_script:
#     - "apt-get install -y $COMPILER_PACKAGE"
#     - "git submodule update --init --recursive"
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#     - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../.."
#   script:
#     - "make VERBOSE=1 -j $(nproc)"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-clang-70-test:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Test"
#   variables:
#     COMPILER_PACKAGE: clang-7
#     CC: clang-7
#     CXX: clang++-7
#   before_script:
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#   script:
#     - "make ARGS=-V test"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-clang-80-build:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Build"
#   variables:
#     COMPILER_PACKAGE: clang-8
#     CC: clang-8
#     CXX: clang++-8
#   before_script:
#     - "apt-get install -y $COMPILER_PACKAGE"
#     - "git submodule update --init --recursive"
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#     - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../.."
#   script:
#     - "make VERBOSE=1 -j $(nproc)"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-clang-80-test:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Test"
#   variables:
#     COMPILER_PACKAGE: clang-8
#     CC: clang-8
#     CXX: clang++-8
#   before_script:
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#   script:
#     - "make ARGS=-V test"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-gcc-46-build:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Build"
#   variables:
#     COMPILER_PACKAGE: g++-4.6
#     CC: gcc-4.6
#     CXX: g++-4.6
#   before_script:
#     - "apt-get install -y $COMPILER_PACKAGE"
#     - "git submodule update --init --recursive"
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#     - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../.."
#   script:
#     - "make VERBOSE=1 -j $(nproc)"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-gcc-46-test:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Test"
#   variables:
#     COMPILER_PACKAGE: g++-4.6
#     CC: gcc-4.6
#     CXX: g++-4.6
#   before_script:
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#   script:
#     - "make ARGS=-V test"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-gcc-47-build:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Build"
#   variables:
#     COMPILER_PACKAGE: g++-4.7
#     CC: gcc-4.7
#     CXX: g++-4.7
#   before_script:
#     - "apt-get install -y $COMPILER_PACKAGE"
#     - "git submodule update --init --recursive"
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#     - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../.."
#   script:
#     - "make VERBOSE=1 -j $(nproc)"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-gcc-47-test:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Test"
#   variables:
#     COMPILER_PACKAGE: g++-4.7
#     CC: gcc-4.7
#     CXX: g++-4.7
#   before_script:
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#   script:
#     - "make ARGS=-V test"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-gcc-48-build:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Build"
#   variables:
#     COMPILER_PACKAGE: g++-4.8
#     CC: gcc-4.8
#     CXX: g++-4.8
#   before_script:
#     - "apt-get install -y $COMPILER_PACKAGE"
#     - "git submodule update --init --recursive"
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#     - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../.."
#   script:
#     - "make VERBOSE=1 -j $(nproc)"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

# trusty-gcc-48-test:
#   image: arthurafarias/toolchain-cppbase:trusty
#   stage: "Test"
#   variables:
#     COMPILER_PACKAGE: g++-4.8
#     CC: gcc-4.8
#     CXX: g++-4.8
#   before_script:
#     - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
#   script:
#     - "make ARGS=-V test"
#   cache:
#     paths:
#       - "build/$COMPILER_PACKAGE"
#   artifacts:
#     name: "build-debug-$COMPILER_PACKAGE"
#     paths:
#       - "build/$COMPILER_PACKAGE"

trusty-gcc-49-build:
  image: arthurafarias/toolchain-cppbase:trusty
  stage: "Build"
  variables:
    COMPILER_PACKAGE: g++-4.9
    CC: gcc-4.9
    CXX: g++-4.9
  before_script:
    - "apt-get install -y $COMPILER_PACKAGE"
    - "git submodule update --init --recursive"
    - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
    - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../.."
  script:
    - "make VERBOSE=1 -j $(nproc)"
  cache:
    paths:
      - "build/$COMPILER_PACKAGE"
  artifacts:
    name: "build-debug-$COMPILER_PACKAGE"
    paths:
      - "build/$COMPILER_PACKAGE"

trusty-gcc-49-test:
  image: arthurafarias/toolchain-cppbase:trusty
  stage: "Test"
  variables:
    COMPILER_PACKAGE: g++-4.9
    CC: gcc-4.9
    CXX: g++-4.9
  before_script:
    - "apt-get install -y $COMPILER_PACKAGE"
    - "git submodule update --init --recursive"
    - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
  script:
    - "make ARGS=-V test"
  cache:
    paths:
      - "build/$COMPILER_PACKAGE"
  artifacts:
    name: "build-debug-$COMPILER_PACKAGE"
    paths:
      - "build/$COMPILER_PACKAGE"

trusty-gcc-50-build:
  image: arthurafarias/toolchain-cppbase:trusty
  stage: "Build"
  variables:
    COMPILER_PACKAGE: g++-5
    CC: gcc-5
    CXX: g++-5
  before_script:
    - "apt-get install -y $COMPILER_PACKAGE"
    - "git submodule update --init --recursive"
    - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
    - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../.."
  script:
    - "make VERBOSE=1 -j $(nproc)"
  cache:
    paths:
      - "build/$COMPILER_PACKAGE"
  artifacts:
    name: "build-debug-$COMPILER_PACKAGE"
    paths:
      - "build/$COMPILER_PACKAGE"

trusty-gcc-50-test:
  image: arthurafarias/toolchain-cppbase:trusty
  stage: "Test"
  variables:
    COMPILER_PACKAGE: g++-5
    CC: gcc-5
    CXX: g++-5
  before_script:
    - "apt-get install -y $COMPILER_PACKAGE"
    - "git submodule update --init --recursive"
    - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
  script:
    - "make ARGS=-V test"
  cache:
    paths:
      - "build/$COMPILER_PACKAGE"
  artifacts:
    name: "build-debug-$COMPILER_PACKAGE"
    paths:
      - "build/$COMPILER_PACKAGE"

trusty-gcc-60-build:
  image: arthurafarias/toolchain-cppbase:trusty
  stage: "Build"
  variables:
    COMPILER_PACKAGE: g++-6
    CC: gcc-6
    CXX: g++-6
  before_script:
    - "apt-get install -y $COMPILER_PACKAGE"
    - "git submodule update --init --recursive"
    - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
    - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../.."
  script:
    - "make VERBOSE=1 -j $(nproc)"
  cache:
    paths:
      - "build/$COMPILER_PACKAGE"
  artifacts:
    name: "build-debug-$COMPILER_PACKAGE"
    paths:
      - "build/$COMPILER_PACKAGE"

trusty-gcc-60-test:
  image: arthurafarias/toolchain-cppbase:trusty
  stage: "Test"
  variables:
    COMPILER_PACKAGE: g++-6
    CC: gcc-6
    CXX: g++-6
  before_script:
    - "apt-get install -y $COMPILER_PACKAGE"
    - "git submodule update --init --recursive"
    - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
  script:
    - "make ARGS=-V test"
  cache:
    paths:
      - "build/$COMPILER_PACKAGE"
  artifacts:
    name: "build-debug-$COMPILER_PACKAGE"
    paths:
      - "build/$COMPILER_PACKAGE"

trusty-gcc-70-build:
  image: arthurafarias/toolchain-cppbase:trusty
  stage: "Build"
  variables:
    COMPILER_PACKAGE: g++-7
    CC: gcc-7
    CXX: g++-7
  before_script:
    - "apt-get install -y $COMPILER_PACKAGE"
    - "git submodule update --init --recursive"
    - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
    - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../.."
  script:
    - "make VERBOSE=1 -j $(nproc)"
  cache:
    paths:
      - "build/$COMPILER_PACKAGE"
  artifacts:
    name: "build-debug-$COMPILER_PACKAGE"
    paths:
      - "build/$COMPILER_PACKAGE"

trusty-gcc-70-test:
  image: arthurafarias/toolchain-cppbase:trusty
  stage: "Test"
  variables:
    COMPILER_PACKAGE: g++-7
    CC: gcc-7
    CXX: g++-7
  before_script:
    - "apt-get install -y $COMPILER_PACKAGE"
    - "git submodule update --init --recursive"
    - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
  script:
    - "make ARGS=-V test"
  cache:
    paths:
      - "build/$COMPILER_PACKAGE"
  artifacts:
    name: "build-debug-$COMPILER_PACKAGE"
    paths:
      - "build/$COMPILER_PACKAGE"

trusty-gcc-80-build:
  image: arthurafarias/toolchain-cppbase:trusty
  stage: "Build"
  variables:
    COMPILER_PACKAGE: g++-8
    CC: gcc-8
    CXX: g++-8
  before_script:
    - "apt-get install -y $COMPILER_PACKAGE"
    - "git submodule update --init --recursive"
    - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
    - "cmake -DPISTACHE_BUILD_TESTS=true -DPISTACHE_SSL=yes -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=$CXX -DCMAKE_CC_COMPILER=$CC ../.."
  script:
    - "make VERBOSE=1 -j $(nproc)"
  cache:
    paths:
      - "build/$COMPILER_PACKAGE"
  artifacts:
    name: "build-debug-$COMPILER_PACKAGE"
    paths:
      - "build/$COMPILER_PACKAGE"

trusty-gcc-80-test:
  image: arthurafarias/toolchain-cppbase:trusty
  stage: "Test"
  variables:
    COMPILER_PACKAGE: g++-8
    CC: gcc-8
    CXX: g++-8
  before_script:
    - "apt-get install -y $COMPILER_PACKAGE"
    - "git submodule update --init --recursive"
    - "mkdir -p build/$COMPILER_PACKAGE && cd build/$COMPILER_PACKAGE"
  script:
    - "make ARGS=-V test"
  cache:
    paths:
      - "build/$COMPILER_PACKAGE"
  artifacts:
    name: "build-debug-$COMPILER_PACKAGE"
    paths:
      - "build/$COMPILER_PACKAGE"
